// import 'dart:math';

import 'package:kenken/kenken.dart';
import 'package:test/test.dart';

void main() {
  group('Function tests', () {
    test('isUniq', () {
      expect(isUniq([1, 2, 3]).value, equals(true));
      expect(isUniq([1, 2, 1]).value, equals(false));
      expect(isUniq([1, 2, 2]).value, equals(false));
      expect(
          isUniq([
            1,
            2,
          ]).value,
          equals(true));
      expect(
          isUniq([
            1,
          ]).value,
          equals(true));
    });
  });

  group('Kenken tests', () {
    Kenken kenken;

    setUp(() {
      kenken = Kenken(3);
      var values = [
        [1, 2, 3], // row = 1,
        [2, 3, 1], // row = 2,
        [3, 1, 2], // row = 3,
      ];
      // Fill kenken cells with values:
      for (var rowInd in List.generate(kenken.size, (i) => i)) {
        var row = rowInd + 1;
        for (var colInd in List.generate(kenken.size, (i) => i)) {
          var col = colInd + 1;
          kenken.setCell(row, col, values[rowInd][colInd]);
        }
      }

      // set common kekken rules
      kenken.rules = kenken.rowColRules;

      // set custom rules
      kenken.rules

        // Cell 1,1 shoul be equal 1:
        ..add(Rule([CellWithRC(1, 1)], Operation(singleValue, label: '1'),
            ShouldHaveResult(1)))

        // Sum of cells 1,2 and 1,3 should be equal 5:
        ..add(Rule([CellWithRC(1, 2), CellWithRC(1, 3)],
            Operation(sum, label: '+'), ShouldHaveResult(5)))

        // Diff between 2,1 and 3,1 should be 1:
        ..add(Rule([CellWithRC(2,1),CellWithRC(3,1)], Operation(diff,label: '-'), ShouldHaveResult(1)))

        // sum of 2,2 2,3 should be 4
        ..add(Rule([CellWithRC(2,2),CellWithRC(2,3)], Operation(sum,label: '+'),ShouldHaveResult(4)))

        // sum of 3,2 and 3,3 should be 3:
        ..add(Rule([CellWithRC(3,2),CellWithRC(3,3)],Operation(sum,label: '+'),ShouldHaveResult(3)));
    });

    test('row and col coordinates', () {
      var row2Coordinates = kenken.coordinatesOfRow(2);
      // first coordinate of row2Coordinates:
      expect(row2Coordinates[0].row, equals(2));
      expect(row2Coordinates[0].col, equals(1));
      // third coordinate of row2Coordinates:
      expect(row2Coordinates[2].row, equals(2));
      expect(row2Coordinates[2].col, equals(3));
    });

    test('First Test', () {
      // expect(awesome.isAwesome, isTrue);
      expect(kenken.invalidRules, equals([]));
    });
  });
}
